#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2005,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

# @(#) 1.6 src/ppe/poe/install.linux/bin/pe_deinstall.sh, ppe.poe.install, ppe_rsanlx, rsanlxs002b 06/09/27 13:42:24
# IBM PE de-install script.

USAGE="${0}:\n
This script delete the IBM Parallel Environment for Linux from a system.\n 
It automatically removes the RPM of every Parallel environment components.\n
This script can only be run by a root-level user.  Once invoked it runs\n
automatically and the deinstallation process begins immediately. \n
It may also be invoked in conjunction with other network utilities such as\n
'dsh', 'rsh', or 'ssh' to de-install the IBM PE from a cluster of nodes.\n
It has one flag:\n
[-keep]: Remove all IBM PE components EXCEPT the License RPM.  Use this flag\n
\tto remove old release level before installing new service level.\n
\n
See the PE Installation documentation for more information. \n"

REMOVE_LICENSE='Y'

if [[ $1 = '-h' ]] then
   print $USAGE
   exit 0
elif [[ $1 = '-keep' ]]  then
     REMOVE_LICENSE='N'
fi

CURR_OS=""
if [[ -a /etc/SuSE-release ]] then
   OS_VERSION=`cat /etc/SuSE-release | grep "SUSE LINUX Enterprise Server 9"`
   if [[ -n $OS_VERSION ]] then
      CURR_OS=sles900
   fi
elif [[ -a /etc/redhat-release ]] then
   OS_VERSION=`cat /etc/redhat-release | grep "Red Hat Enterprise Linux AS release 4"`
   if [[ -n $OS_VERSION ]] then
      CURR_OS=rh400
   fi
fi 

if [[ -z $CURR_OS ]] then
   print "Cannot determine version of operation system"
   exit 1
fi

ARCH=`arch`

if [[ $ARCH == 'ppc64' ]] then
   print "rpm -e ppe_ppc_64bit_${CURR_OS}"
          rpm -e ppe_ppc_64bit_${CURR_OS}
   print "rpm -e ppe_ppc_base_32bit_${CURR_OS}"
          rpm -e ppe_ppc_base_32bit_${CURR_OS}
#  print "rpm -e lapi_ppc_64bit_US_${CURR_OS}"
#         rpm -e lapi_ppc_64bit_US_${CURR_OS}
   print "rpm -e lapi_ppc_64bit_IP_${CURR_OS}"
          rpm -e lapi_ppc_64bit_IP_${CURR_OS}
#  print "rpm -e lapi_ppc_32bit_US_${CURR_OS}"
#         rpm -e lapi_ppc_32bit_US_${CURR_OS}
   print "rpm -e lapi_ppc_32bit_base_IP_${CURR_OS}"
          rpm -e lapi_ppc_32bit_base_IP_${CURR_OS}
#  print "rpm -e rsct*"
#         rpm -e rsct*
#  print "rpm -e src*"
#         rpm -e src*
else
   if [[ $ARCH == 'i386' || $ARCH == 'i686' ]] then
      print "rpm -e ppe_x86_base_32bit_${CURR_OS}"
             rpm -e ppe_x86_base_32bit_${CURR_OS}
      print "rpm -e lapi_x86_32bit_base_IP_${CURR_OS}"
             rpm -e lapi_x86_32bit_base_IP_${CURR_OS}
#     print "rpm -e lapi_x86_32bit_US_${CURR_OS}"
#            rpm -e lapi_x86_32bit_US_${CURR_OS}
#     print "rpm -e rsct*"
#            rpm -e rsct*
#     print "rpm -e src*"
#            rpm -e src*
   else
      if [[ $ARCH == 'x86_64' ]] then
         print "rpm -e ppe_x86_64bit_${CURR_OS}"
                rpm -e ppe_x86_64bit_${CURR_OS}
         print "rpm -e ppe_x86_base_32bit_${CURR_OS}"
                rpm -e ppe_x86_base_32bit_${CURR_OS}
#        print "rpm -e lapi_x86_64bit_US_${CURR_OS}"
#               rpm -e lapi_x86_64bit_US_${CURR_OS}
         print "rpm -e lapi_x86_64bit_IP_${CURR_OS}"
                rpm -e lapi_x86_64bit_IP_${CURR_OS}
#        print "rpm -e lapi_x86_32bit_US_${CURR_OS}"
#               rpm -e lapi_x86_32bit_US_${CURR_OS}
         print "rpm -e lapi_x86_32bit_base_IP_${CURR_OS}"
                rpm -e lapi_x86_32bit_base_IP_${CURR_OS}
#        print "rpm -e rsct*"
#               rpm -e rsct*
#        print "rpm -e src*"
#               rpm -e src*
      else
         print "Abort: Platform ...${ARCH}... is not supported."
         exit 1
      fi
   fi
fi

if [[ $REMOVE_LICENSE = 'Y' ]] then
   rpm -e IBM_pe_license
fi
