/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1997,2005          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#include "mpi.h"
#include <stdio.h>


/*************************************************************************
*   This program is intended to be used to verify basic operation of     *
*   64 bit MPI.                                                          *
*************************************************************************/

main()
{
   int len,finrc,me,tasks;
   long data;
   MPI_Status status;

   MPI_Init(0,0);
   MPI_Comm_rank(MPI_COMM_WORLD,&me);
   MPI_Comm_size(MPI_COMM_WORLD,&tasks);

   if (tasks < 2)  {
      printf( "Run this program with at least 2 tasks\n");
      MPI_Abort( MPI_COMM_WORLD, 99 );
   }

   MPI_Barrier(MPI_COMM_WORLD);
   if(me==0) {
      data = 9876543210;
      printf("Task 0 Sending an MPI_LONG with value 9876543210\n");
      MPI_Send(&data,1,MPI_LONG,1,1,MPI_COMM_WORLD); 
   } else if(me == 1) {
      data = 0;
      MPI_Recv(&data,1,MPI_LONG,0,1,MPI_COMM_WORLD,&status);
      if (data == 9876543210) {
          printf("Task 1 Received an MPI_LONG with value %ld\n",data);
      }else{
          printf("ERROR:Task 1 received an MPI_LONG with wrong value %d!!\n",data);
      }
   }
   MPI_Barrier(MPI_COMM_WORLD);
   finrc = MPI_Finalize();
   if (finrc == MPI_SUCCESS){
       if(me == 0)  printf("TEST COMPLETE\n");
   }
   exit(0);

}
